/****************************************************************************\ 
*  Tilt : A Java game for mobile phones                                      *
*  Copyright (C) 2003 Alan Waddington                                        *
*                                                                            *
*  This program is free software; you can redistribute it and/or modify      *
*  it under the terms of the GNU General Public License as published by      *
*  the Free Software Foundation; either version 2 of the License, or         *
*  (at your option) any later version.                                       *
*                                                                            *
*  This program is distributed in the hope that it will be useful,           *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*  GNU General Public License for more details.                              *
*                                                                            *
*  You should have received a copy of the GNU General Public License         *
*  along with this program; if not, write to the Free Software               *
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *  
\****************************************************************************/
/*
 * Board.java
 *
 * Created on 10 May 2003, 07:38
 */

package Tilt;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import com.siemens.mp.io.*;

/**
 *
 * @author  Alan Waddington
 * @version
 */
class Board {
    public Game parent;
    public Images im;
    private Ball bl;
    public Image sc;
    public Image icon[][];
    public int height, width, colours;
    public boolean colour;
    private boolean newLevel = false;
    public int xm, ym;
    public int level = 1;
    public int xp=0, yp=0, xv=0, yv=0;
    static int X_MAX = 15;
    static int Y_MAX = 15;
    static int Z_MAX = 6;
    private int i, j, k;
    private RecordStore rs;
    
    //*********Paste in Starting Level Design**********//
    public byte b[][][] = { {
        { 20,20,20,20,20,20,20,20,20,20,20,20,20,20,20 },
        { 23,23,23,23,23,23,23,23,23,23,23,23,23,23,23 },
        { 23,23, 3,19,19,19,11,23, 3,11, 3,11,23,23,23 },
        { 23,23,23, 3,11,23,23, 3,11, 3,19,11,23,23,23 },
        { 23,23, 3,11, 3,11, 3,11, 3,11,23,23,23,23,23 },
        { 23, 3,11, 3,11, 3,11, 3,19,11,23,23,23,23,23 },
        { 23,23,23,23,23,23,23,23,23,23,23,23,23,23,23 },
        { 20,20,20,20,20,20,20,20,20,20,20,20,20,20,20 },
        { 21,21,21,21,21,21,21,21,21,21,21,21,21,21,21 },
        { 21,21,21, 1,17,17, 9,21, 1, 9, 1, 9,21,21,21 },
        { 21,21,21, 1, 9,21,21, 1, 9, 1,17, 9,21,21,21 },
        { 21,21, 1, 9, 1, 9, 1, 9, 1, 9,21,21,21,21,21 },
        { 21, 1, 9, 1, 9, 1, 9, 1,17, 9,21,21,21,21,21 },
        { 21,21,21,21,21,21,21,21,21,21,21,21,21,21,21 },
        { 20,20,20,20,20,20,20,20,20,20,20,20,20,20,20 },
    }, {
        { 18,18,18,18,18,18,18,18,18,18,18,18,18,18,18 },
        { 18,22,22,22,22,22,22,22,22,22,22,22,22,22,18 },
        { 18,22,22,22,22,22,22,22,22,22,22,22,22,22,18 },
        { 18,22,22,18,18,18,18,18,18,18,18,18,22,22,18 },
        { 18,22,22,18,22,22,22,22,22,27,27,18,22,22,18 },
        { 18,22,22,18,22,22,22,22,22,27,27,18,22,22,18 },
        { 18,22,22,18,22,22,18,18,18,18,18,18,22,22,18 },
        { 18,22,22,18,22,22,18,22,22,22,22,22,22,22,18 },
        { 18,22,22,18,22,22,18,22,22,22,22,22,22,22,18 },
        { 18,22,22,18,22,22,22,22,22,22,22,18,18,18,18 },
        { 18,22,22,18,22,22,22,22,22,22,22,18,22,22,18 },
        { 18,22,22,18,18,18,18,18,18,18,18,18,22,22,18 },
        { 18,22,22,22,22,22,22,22,22,22,22,22,22,22,18 },
        { 18,22,22,22,22,22,22,22,22,22,22,22,22,22,18 },
        { 18,18,18,18,18,18,18,18,18,18,18,18,18,18,18 },
    }, {
        { 19,19,19,19,19,19,19,19,19,19,19,19,19,19,19 },
        { 19,19,19,11,23,23,23,23,23,23,15,19,19,19,19 },
        { 19,19,11,23, 3,19,19,19, 7,23,23,15,19,19,19 },
        { 19,11,23, 3,19,11,23,23,23,23,23,23,15,19,19 },
        { 19,23, 3,19,11,23,23,23,23,23,23,23,23,15,19 },
        { 19,23,19,11,23,23,31, 3,19,19,19, 7,23,23,19 },
        { 19,23,19,23,23,23,31,24,24,23,23,23,23,23,19 },
        { 19,23,23,23,23,23,31,24,24,23,23,23,23,23,19 },
        { 19,23,23,23,23,23,31,31,31,19,23,23,23,23,19 },
        { 19,23,19,23,23,23,23,23,23,19, 7,23,23, 3,19 },
        { 19,23,19, 7,23,23,23,23, 3,19,19,19,19,19,19 },
        { 19,23,15,19, 7,23,23, 3,19,11,23,23,15,19,19 },
        { 19,23,23,15,19,19,19,19,11,23,23,23,23,19,19 },
        { 19,23,23,23,23,23,23,23,23,23,23,23, 3,19,19 },
        { 19,19,19,19,19,19,19,19,19,19,19,19,19,19,19 },
    }, {
        { 16,16,16,16,16,16,16,16,16,16,16,16,16,16,16 },
        { 16,20,20,12, 8,20,20,20,20,20,20,20,20,20,16 },
        { 16,20,24,20,20,20,20,20,20,20,20,20,20,20,16 },
        { 16, 4,20,20,20,20, 0,20, 4,20,20,20,20, 0,16 },
        { 16, 8,28,28,16,16,16,20,12, 4,28,28,28,12,16 },
        { 16,20,20,20,16,16,16,20,20,12, 4,20,20,20,16 },
        { 16,20,20, 0,16,16,16, 4,20,20,12, 4,20,20,16 },
        { 16,20,20,20,20,20,12,16, 4,20,20,20,20,20,16 },
        { 16,20,20,12, 4,20,20,12,16,16,16, 8,20,20,16 },
        { 16,20,20,20,12, 4,20,20,16,16,16,20,20,20,16 },
        { 16, 4,20,20,20,12, 4,20,16,16,16,20,20, 0,16 },
        { 16, 8,20,20,20,28,12,20, 8,20,20,20,20,12,16 },
        { 16,20,20,20,20,28,20,20,20,20,20,20,20,20,16 },
        { 16,20,20, 0, 4,28,20,20,20,20,20,20,20,20,16 },
        { 16,16,16,16,16,16,16,16,16,16,16,16,16,16,16 },
    }, {
        { 17,17,17,17,17,17,17,17,17,17,17,17,17,17,17 },
        { 17,29,13, 9,29,29,29, 1, 9,21,21,21,21,21,17 },
        { 17, 5,21,21,21,21,21,21,21,21,21,21,21,21,17 },
        { 17, 9,21,21,21,21,21,21,21,21,21,21,21,21,17 },
        { 17,21,21,21, 1,17, 5,21,21, 1, 9,21,21,21,17 },
        { 17,21,21,21, 9,29,13, 5, 1, 9,29,21,21, 1,17 },
        { 17,21,21,21,21,21,29,17, 9,29,21,21, 1, 9,17 },
        { 17, 1,21,21,21,21, 1, 9,21,21,21, 1, 9,29,17 },
        { 17, 9,21,21,21, 1, 9,21,21,21, 1, 9,29,29,17 },
        { 17,21,21,21, 1, 9,21,21,29, 1, 9,29,29,29,17 },
        { 17,21,21, 1, 9,21,21,29, 1, 9,21,21,21, 1,17 },
        { 17,21,21,17,21,21,21,21,21,21,21,21,21,17,17 },
        { 17,21,21,13, 5,21,21,21,21,21,21,21,21,13,17 },
        { 17,21,21,21,13, 5,21,21,21,21, 1,17, 5,25,17 },
        { 17,17,17,17,17,17,17,17,17,17,17,17,17,17,17 },
    }, {
        { 17,17,17,17,17,17,17,17,17,17,16,16,16,16,16 },
        { 17, 9,21,29,21,21,21,21,29,17, 8,20,20,12,16 },
        { 17,21,21,21,21, 1, 5,21,21,21,20,20,25,20,16 },
        { 17,21,21,21,21,13, 9,21,21,21,20,20,25,20,16 },
        { 17,21,21,29,21,21,21,21,29,17, 4,20,20, 0,16 },
        { 17, 5,21,13,17,17,17,17,17,17,16,16,16,16,16 },
        { 19,11,23,23,15,31,31,11,23,23,23,23,15,19,19 },
        { 19,23,23,23,23,23,23,23,23,23,23,23,23,15,19 },
        { 19,31,31, 7,23,23,23,23, 3,31,31, 7,23,23,19 },
        { 19,31,31,19,19,19,19,19,19,19,19,19,23,23,19 },
        { 18,22,22,22,22,22,30,22,22,22,22,22,22,22,18 },
        { 18,22,22,22,22,22,30,22,22,22,22,22,22,22,18 },
        { 18,22,22,18,22,22,22,22,22,18,22,22,22,22,18 },
        { 18,22, 2,18, 6,22,22,22, 2,18, 6,30,30, 2,18 },
        { 18,18,18,18,18,18,18,18,18,18,18,18,18,18,18 },
    } };
    //*********Paste in Starting Level Design**********//
    
    
    Board(Game p) {
        parent = p;
        height = p.getHeight();
        if (height>8*(Y_MAX))
            height = 8*(Y_MAX);
        width = p.getWidth();
        if (width>8*(X_MAX))
            width = 8*(X_MAX);
        colours = p.parent.ds.numColors();
        colour = p.parent.ds.isColor();
        sc = Image.createImage(X_MAX*8,Y_MAX*8);
        im = new Images(colour, colours);
        xm = width/8;
        ym = height/8;
        byte icon, col;
        bl = new Ball(this);
    }
    
    public void newLevel(int l) {
        System.gc();
        synchronized (this) {
            newLevel = true;
            level = l;
            xp = 8;
            yp = (Y_MAX-2)*8;
            bl.newLevel();
        }
    }
    
    public void move(int d) {
        bl.move(d);
    }
    
    public void saveInbox() {
        try {
            rs = RecordStore.openRecordStore("Tilt",true);
            int z = rs.getNumRecords();
            int r=1;
            for (j=0;j<Y_MAX;j++)
                if (r>z)
                    rs.addRecord(b[0][j], 0, X_MAX);
                else
                    rs.setRecord(r++, b[0][j], 0, X_MAX);
            rs.closeRecordStore();
        } catch (RecordStoreException err) { }
    }
    
    public void loadInbox() {
        try {
            rs = RecordStore.openRecordStore("Tilt",false);
            int r=1;
            for (j=0;j<Y_MAX;j++)
                rs.getRecord(r++,b[0][j], 0);
            rs.closeRecordStore();
        } catch (RecordStoreException err) { }
    }
    
    public void saveGame() {
        try {
            rs = RecordStore.openRecordStore("Tilt",true);
            int z = rs.getNumRecords();
            int r=Y_MAX+1;
            for (i=1;i<Z_MAX;i++)
                for (j=0;j<Y_MAX;j++)
                    if (r>z)
                        rs.addRecord(b[i][j], 0, X_MAX);
                    else
                        rs.setRecord(r++, b[i][j], 0, X_MAX);
            rs.closeRecordStore();
        } catch (RecordStoreException err) { }
    }
    
    public void loadGame() {
        try {
            rs = RecordStore.openRecordStore("Tilt",false);
            int r=Y_MAX+1;
            for (i=1;i<Z_MAX;i++)
                for (j=0;j<Y_MAX;j++)
                    rs.getRecord(r++,b[i][j], 0);
            rs.closeRecordStore();
        } catch (RecordStoreException err) { }
    }
    
    public void copyLevel(int copyTo) {
        for (i=0;i<Y_MAX;i++)
            for (j=0;j<X_MAX;j++)
                b[copyTo][i][j] = b[level][i][j];
    }
    
    public void paint(Graphics g) {
        int x, y, i, j, ii, jj, mi, mj, t;
        int Lxx, Lxo, Mxx, Mxo, Rxx, Rxo, xx, xo;
        int Lyy, Lyo, Myy, Myo, Ryy, Ryo, yy, yo;
        Graphics g2;
        Lxx = 0;                    // Board X offset when ball on left
        Lxo = 0;
        Mxx = (xp>>3) - (xm>>1);    // Board X offset when ball in middle
        Mxo = -(xp&7);
        Rxx = X_MAX-xm-1;           // Board X offset when ball on right
        Rxo = -(8-(width&7));
        xx = Mxx;                   // Start by assuming ball in the middle
        xo = Mxo;
        if (Mxx<Lxx) {              // If the X offset to keep the ball in
            xx = Lxx;               // the middle is negative, the the ball
            xo = Lxo;               // is on the left
        }
        if (Mxx>Rxx) {              // If the X offset to keep the ball in
            xx = Rxx;               // the middle exceeds the offset to keep
            xo = Rxo;               // the ball on the right, we are on right.
        } else if ((Mxx==Rxx) && (Mxo<Rxo)) {
            xx = Rxx;
            xo = Rxo;
        }
        Lyy = 0;
        Lyo = 0;
        Myy = (yp>>3) - (ym>>1);
        Myo = -(yp&7);
        Ryy = Y_MAX-ym-1;
        Ryo = -(8-(height&7));
        yy = Myy;
        yo = Myo;
        if (Myy<Lyy) {
            yy = Lyy;
            yo = Lyo;
        }
        if (Myy>Ryy) {
            yy = Ryy;
            yo = Ryo;
        } else if ((Myy==Ryy) && (Myo<Ryo)) {
            yy = Ryy;
            yo = Ryo;
        }
        if (parent.editMode | newLevel) {
            newLevel = false;
            ii = yy;
            mi = xo +((ym+2)<<3);
            mj = yo + ((xm+2)<<3);
            g2 = sc.getGraphics();
            for (i=0;i<Y_MAX;i++)
                for (j=0;j<X_MAX;j++) {
                    t = b[level][i][j];
                    g2.drawImage(icon[(t>>2)][(t&3)],j<<3,i<<3,g.TOP|g.LEFT);
                }
        }
        i = yp - (height>>1);
        ii= Y_MAX*8 - height;
        if (i<0)
            i = 0;
        if (i>ii)
            i = ii;
        j = xp - (width>>1);
        jj = X_MAX*8 -width;
        if (j<0)
            j = 0;
        if (j>jj)
            j = jj;
        g.drawImage(sc, -j, -i, g.TOP | g.LEFT);
        if (parent.editMode) {
            // Draw caret
            x = (xp>>3) - xx;
            y = (yp>>3) - yy;
            g.setColor(0x00FFFFFF);
            g.drawRect(xo+x*8-2,yo+y*8-2,10,10);
            g.setColor(0x00000000);
            g.drawRect(xo+x*8-1,yo+y*8-1,10,10);
        } else {
            x = xp - xx*8 + xo;
            y = yp - yy*8 + yo;
            //            bl.paint(g, x, y);
            g.setColor(0x00000000);
            g.fillArc(x,y,8,8,0,360);
        }
    }
    
    // Construct Images
    class Images {
        
        Images(boolean colour, int colours) {
            Graphics g;
            int i, j, c, c2;
            icon = new Image[8][4];
            for (i=0;i<4;i++) // Colour Triangles
                for (c=0;c<4;c++) {
                    icon[i][c] = Image.createImage(8,8);
                    g = icon[i][c].getGraphics();
                    // Draw the background
                    if (colours==2)
                        c2 = 0; // B&W mode
                    else
                        c2 = c;
                    if (c2 == 0)
                        g.setColor(0x00FFFFFF);
                    else
                        g.setColor(0x00C0C0C0+(0x3F<<((3-c2)*8)));
                    g.fillRect(0,0,8,8);
                    // Draw the triangle
                    g.setColor(0xFF<<((3-c2)*8));
                    for (j=0;j<7;j++)
                        switch (i) {
                            case 0:
                                g.drawLine(7-j,7,7,7-j);
                                break;
                            case 1:
                                g.drawLine(0,7-j,j,7);
                                break;
                            case 2:
                                g.drawLine(j,0,0,j);
                                break;
                            case 3:
                                g.drawLine(7,j,7-j,0);
                        }
                }
            for (c=0;c<4;c++) { // Colour Blocks
                icon[4][c] = Image.createImage(8,8);
                g = icon[4][c].getGraphics();
                if (colours==2)
                    c2 = 0; // B&W mode
                else
                    c2 = c;
                g.setColor(0xFF<<((3-c2)*8));
                g.fillRect(0,0,8,8);
            }
            for (c=0;c<4;c++) { // Colour Spaces
                icon[5][c] = Image.createImage(8,8);
                g = icon[5][c].getGraphics();
                if (colours==2)
                    c2 = 0; // B&W mode
                else
                    c2 = c;
                if (c2 == 0)
                    g.setColor(0x00FFFFFF);
                else
                    g.setColor(0x00C0C0C0+(0x3F<<((3-c2)*8)));
                g.fillRect(0,0,8,8);
            }
            for (c=0;c<4;c++) { // Up Icon +
                icon[6][c] = Image.createImage(8,8);
                g = icon[6][c].getGraphics();
                if (colours==2)
                    c2 = 0; // B&W mode
                else
                    c2 = c;
                if (c2 == 0)
                    g.setColor(0x00FFFFFF);
                else
                    g.setColor(0x00C0C0C0+(0x3F<<((3-c2)*8)));
                g.fillRect(0,0,8,8);
                g.setColor(0x00000000);
                g.drawRect(0,0,7,7);
            }
            for (c=0;c<4;c++) { // Down Icon X
                icon[7][c] = Image.createImage(8,8);
                g = icon[7][c].getGraphics();
                if (colours==2)
                    c2 = 0; // B&W mode
                else
                    c2 = c;
                if (c2 == 0)
                    g.setColor(0x00FFFFFF);
                else
                    g.setColor(0x00C0C0C0+(0x3F<<((3-c2)*8)));
                g.fillRect(0,0,8,8);
                g.setColor(0x00000000);
                g.drawLine(0,0,7,7);
                g.drawLine(0,7,7,0);
            }
        }
    }
    
    class Ball {
        private int xpm, ypm, xv, yv;
        private int MAX_V = 3;
        
        private Board parent;
        
        Ball(Board p) {
            parent = p;
        }
        
        public void newLevel() {
            xpm = parent.xp<<1;
            ypm = parent.yp<<1;
            xv = 0;
            yv = 0;
        }
        
        // return 0=empty, 1=collision, 2=up, 3=down
        public int Sensor(int x, int y) {
            int xx = ((xpm>>1) + x)>>3;
            int yy = ((ypm>>1) + y)>>3;
            int xo = ((xpm>>1) + x)&7;
            int yo = ((ypm>>1) + y)&7;
            int r = 0;
            if ((xx<0) || (xx>=parent.X_MAX) || (yy<0) || (yy>=parent.Y_MAX)) {
                return 1; // off board
            } else {
                int b = parent.b[parent.level][yy][xx];
                int i = (b>>2)&7;
                switch (i) {
                    case 0: // Triangle 0
                        if (xo>7-yo)
                            r=1;
                        break;
                    case 1: // Triangle 1
                        if (xo<yo)
                            r=1;
                        break;
                    case 2: // Triangle 2
                        if (xo<7-yo)
                            r=1;
                        break;
                    case 3: // Triangle 3
                        if (xo>yo)
                            r=1;
                        break;
                    case 4: // Solid Block (not transparent)
                        r = 1;
                        break;
                    case 5: // Empty Block
                        r = 0;
                        break;
                    case 6: // Up
                        r = 2;
                        break;
                    case 7: // Down
                        r = 3;
                }
                return r;
            }
        }
        
        // Attempt to move ball
        public void move(int d) {
            int t, oxpm, oypm;
            oxpm = xpm;
            oypm = ypm;
            switch (d) {
                case Canvas.UP:
                    if (yv>-MAX_V) yv--;
                    break;
                case Canvas.DOWN:
                    if (yv<MAX_V) yv++;
                    break;
                case Canvas.LEFT:
                    if (xv>-MAX_V) xv--;
                    break;
                case Canvas.RIGHT:
                    if (xv<MAX_V) xv++;
                    break;
                default:
            }
            xpm+=xv;
            ypm+=yv;
            
            // Check for Collisions
            
            int sn = Sensor(4,1);
            int se = Sensor(7,4);
            int ss = Sensor(4,7);
            int sw = Sensor(1,4);
            
            if ((sn==2) | (se==2) | (ss==2) | (sw==2)) {
                // Move up a level
                parent.parent.updateScore(75 + parent.level*25);
                if ((parent.level>0) & (parent.level<Board.Z_MAX-1))
                    parent.newLevel(parent.level+1);
                else
                    parent.parent.gameOver = true;
            } else if ((sn==3) | (se==3) | (ss==3) | (sw==3)) {
                // Move down a level
                parent.parent.updateScore(-(75 + parent.level*25));
                if (parent.level>1)
                    parent.newLevel(parent.level-1);
                else
                    parent.newLevel(parent.level);
            } else {
                // If we are in 'the rough' try applying logic to previous position
                if ((sn==1) & (se==1) & (ss==1) & (sw==1)) {
                    xv = -xv;
                    yv = -yv;
                    xp = oxpm;
                    yp = oypm;
                    sn = Sensor(4,1);
                    se = Sensor(7,4);
                    ss = Sensor(4,7);
                    sw = Sensor(1,4);
                }
                if ((sn==1) & (ss!=1) & !((se!=1) ^ (sw!=1))) // North Collision
                    if (yv<0)
                        yv = -yv;
                    else if (yv==0)
                        yv = 1;
                
                if ((se==1) & (sw!=1) & !((sn!=1) ^ (ss!=1))) // East Collision
                    if (xv>0)
                        xv = -xv;
                    else if (xv==0)
                        xv = -1;
                if ((ss==1) & (sn!=1) & !((se!=1) ^ (sw!=1))) // South Collision
                    if (yv>0)
                        yv = -yv;
                    else if (yv==0)
                        yv = -1;
                if ((sw==1) & (se!=1) & !((sn!=1) ^ (ss!=1))) // West Collision
                    if (xv<0)
                        xv = -xv;
                    else if (xv==0)
                        xv = 1;
                if ((sn==1) & (se==1) & (ss!=1) & (sw!=1)) { // Northeast Collision
                    t = xv;
                    xv = yv;
                    yv = t;
                }
                if ((sn!=1) & (se==1) & (ss==1) & (sw!=1)) { // Southeast Collision
                    t = xv;
                    xv = -yv;
                    yv = -t;
                }
                if ((sn!=1) & (se!=1) & (ss==1) & (sw==1)) { // Southwest Collision
                    t = xv;
                    xv = yv;
                    yv = t;
                }
                if ((sn==1) & (se!=1) & (ss!=1) & (sw==1)) { // Northwest Collision
                    t = xv;
                    xv = -yv;
                    yv = -t;
                }
                
                // Stop stepwise movement at low speed
                if (((xv==1)|(xv==-1))&((yv==1)|(yv==-1))&((xpm&1)!=(ypm&1))) {
                    xpm = xpm | 1;
                    ypm = ypm | 1;
                }
                
                // Modify the move if there were collisions
                if ((se==1) | (sw==1))
                    xp+=xv;
                if ((sn==1) | (ss==1))
                    yp+=yv;
                if (xv>0)
                    parent.xp = (xpm+1)>>1;
                else
                    parent.xp = xpm>>1;
                if (yv>0)
                    parent.yp = (ypm+1)>>1;
                else
                    parent.yp = ypm>>1;
            }
        }
    }
}

