/****************************************************************************\ 
*  Tilt : A Java game for mobile phones                                      *
*  Copyright (C) 2003 Alan Waddington                                        *
*                                                                            *
*  This program is free software; you can redistribute it and/or modify      *
*  it under the terms of the GNU General Public License as published by      *
*  the Free Software Foundation; either version 2 of the License, or         *
*  (at your option) any later version.                                       *
*                                                                            *
*  This program is distributed in the hope that it will be useful,           *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*  GNU General Public License for more details.                              *
*                                                                            *
*  You should have received a copy of the GNU General Public License         *
*  along with this program; if not, write to the Free Software               *
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *  
\****************************************************************************/
/*
 * Tilt.java
 *
 * Created on 02 June 2003, 18:36
 */

package Tilt;

import java.io.*;
import java.lang.*;
import com.siemens.mp.io.*;
//import com.siemens.mp.gsm.*;
//import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 *
 * @author  Alan Waddington
 * @version
 */
public class Tilt extends MIDlet implements Runnable {
    public Display display;
    public Splash splash;
    private Thread th = null;
    public Wrapper sms;
    public boolean initialised = false;
    
    public void startApp() {
        if ( !initialised ) {
            // Try to dynamically load SMS without generating an error
            try {
                Class.forName("com.siemens.mp.io.Connection");
                sms = (Wrapper)Class.forName("Tilt.SmsForm").newInstance();
                initialised = true;
            } catch (Exception e) { /* No SMS */ }
            if (!initialised) {
                sms = (Wrapper)(new NoSmsForm());
                initialised = true;
            }
            display = Display.getDisplay(this);
            splash = new Splash();
            display.setCurrent(splash);
            th = new Thread(this);
            th.start();
        }
    }
    
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) {
        this.notifyDestroyed();
    }
    
    public void run() {
        sms.initialise(this);
        display.setCurrent(sms);
    }
    
    class Splash extends Canvas {
        private int left, top;
        private Image im;
        
        public Splash() {
            super();
            try {
                im = Image.createImage("/Tilt/splash.png");
            } catch (Exception e) { e.printStackTrace();}
            left = (getWidth() - im.getWidth())/2;
            if (left<0)
                left = 0;
            top  = (getHeight() - im.getHeight())/2;
            if (top<0)
                top = 0;
        }
        
        public void paint(Graphics g) {
            g.setColor(0x00FFFF00);
            g.fillRect(0,0,getWidth(),getHeight());
            g.drawImage(im, left, top, Graphics.LEFT | Graphics.TOP);
        }
    }
}

class Wrapper extends Form {
    public Display ds;
    Wrapper(java.lang.String title) {
        super(title);
    }
    
    public void initialise(Tilt p) { };
    public void reset(boolean reg) { };
}

//-------------------------------------------------------------------------------------------------------------------------------
// SmsForm
//-------------------------------------------------------------------------------------------------------------------------------
class SmsForm extends Wrapper implements CommandListener, ConnectionListener, Runnable {
    private volatile byte rPtr = 0, wPtr = 0;
    private byte[][] in = new byte[8][];
    Tilt parent;
    private Thread th1 = null, th2 = null;
    private boolean terminate = false, saving = false;
    private Command startCommand;
    private Command optionsCommand;
    public Connection conn  = null;
    public Game gm;
    public Options op;
    public Level lv;
    public SendForm tx;
    public Form hg;
    public Save sa;
    public Receive rx;
    public byte[] sd = new byte[Board.X_MAX * Board.Y_MAX];
    public byte[] rd;
    private byte buf1[] = new byte[256];
    private byte buf2[] = new byte[256];
    private byte out[];
    private boolean changedInbox = false, changed = false;
    Image level, gamepad, editpad;
    //
    //	constructor
    //
    SmsForm() {
        super("Tilt");
    }
    
    public void initialise(Tilt p) {
        parent = p;
        ds = Display.getDisplay(p);
        gm = new Game(this);
        op = new Options(this);
        lv = new Level(this);
        tx = new SendForm(this);
        hg = new Form("Tilt");
        hg.append("Busy...");
        sa = new Save(this);
        rx = new Receive(this);
        gm.bd.loadInbox();
        try {
            level = Image.createImage("/Tilt/level.png");
            gamepad = Image.createImage("/Tilt/gamepad.png");
            editpad = Image.createImage("/Tilt/editpad.png");
        } catch (Exception e) { e.printStackTrace();}
        th1 = new Thread(gm);
        th1.start();
        append("Roll the ball to the entrance of the next level. "+
        "Don't fall back to the previous level.");
        append2(level);
        append("\nGame keys:");
        append2(gamepad);
        append("\nEdit keys:");
        append2(editpad);
        append("\nSELECT key saves.");
        append("\nCopyright Alan Waddington 2003. "+
        "Tilt is freeware and without warranty.");
        startCommand     = new Command("Start", Command.SCREEN, 1);
        optionsCommand	 = new Command("Options", Command.SCREEN, 2);
        addCommand(startCommand);
        addCommand(optionsCommand);
        setCommandListener(this);
        registerListener();
    }
    
    public void reset(boolean reg) {
        if (reg)
            registerListener();
        ds.setCurrent(this);
    }
    
    private void append2(Image img) {
        append(new ImageItem(null, img, ImageItem.LAYOUT_LEFT | ImageItem.LAYOUT_NEWLINE_BEFORE, "failed"));
    }
    
    public void commandAction(Command cmd, Displayable disp) {
        if ( cmd == startCommand ) {
            removeListener(); // No receiving when playing
            gm.setNewGame();
            ds.setCurrent(gm);
        } else if ( cmd == optionsCommand ) {
            ds.setCurrent(op);
        } else if (( cmd == op.SELECT_COMMAND) & (disp == op)) {
            switch (op.getSelectedIndex()) {
                case 0: // Set
                    lv.setLevel(gm.getLevel());
                    ds.setCurrent(lv);
                    break;
                case 1: // Load
                    ds.setCurrent(hg);
                    changed = false;
                    gm.loadGame();
                    break;
                case 2: // Edit
                    if (gm.getLevel()>0)
                        changed = true;
                    else
                        changedInbox = true;
                    gm.setEditMode();
                    ds.setCurrent(gm);
                    break;
                case 3: // Copy
                    lv.setCopyLevel(gm.getLevel());
                    ds.setCurrent(lv);
                    break;
                case 4: // Send
                    for (int y=0;y<Board.Y_MAX;y++)
                        for (int x=0;x<Board.X_MAX;x++)
                            sd[y*Board.X_MAX+x] = gm.bd.b[gm.getLevel()][y][x];
                    byte[] buf = compress(sd);
                    tx.setSize(buf.length);
                    ds.setCurrent(tx);
                    break;
                case 5: // Save
                    ds.setCurrent(hg);
                    changed = false;
                    gm.saveGame();
                    break;
                case 6: // Exit
                    if (changed)
                        ds.setCurrent(sa);
                    else {
                        saving = false;
                        terminate = true;
                        ds.setCurrent(hg);
                        th2 = new Thread(this);
                        th2.start();
                    }
                    break;
            }
        } else if ((cmd == op.backCommand) & (disp == op)) {
            ds.setCurrent(this);
        } else if ((cmd == lv.SELECT_COMMAND) & (disp == lv)) {
            switch (lv.mode) {
                case 0: // Set
                    gm.setLevel(lv.getSelectedIndex());
                    ds.setCurrent(this);
                    break;
                case 1: // Copy
                    gm.copyLevel(lv.getSelectedIndex());
                    if (lv.getLevel()>0)
                        changed = true;
                    else
                        changedInbox = true;
                    ds.setCurrent(this);
                    break;
                case 2: // Save
                    rx.setLevel(lv.getSelectedIndex());
                    ds.setCurrent(rx);
            }
        } else if ((cmd == lv.cancelCommand) & (disp == lv)) {
            switch (lv.mode) {
                case 0: // Set
                case 1: // Copy
                    ds.setCurrent(this);
                    break;
                case 2: // Save
                    ds.setCurrent(rx);
            }
        } else if ((cmd == tx.sendCommand) & (disp == tx)) {
            ds.setCurrent(this);
            terminate = false;
            th2 = new Thread(this);
            th2.start();
        } else if ((cmd == tx.cancelCommand) & (disp == tx)) {
            ds.setCurrent(this);
        } else if ((cmd == sa.yesCommand) & (disp == sa)) {
            saving = true;
            ds.setCurrent(hg);
            terminate = true;
            th2 = new Thread(this);
            th2.start();
        } else if ((cmd == sa.noCommand) & (disp == sa)) {
            saving = false;
            ds.setCurrent(hg);
            terminate = true;
            th2 = new Thread(this);
            th2.start();
        } else if ((cmd == rx.saveAsCommand) & (disp == rx)) {
            lv.setSaveLevel(rx.getLevel());
            ds.setCurrent(lv);
        } else if ((cmd == rx.okCommand) & (disp == rx)) {
            storeReceivedData(rx.getLevel());
            if (rx.getLevel()>0)
                changed = true;
            else
                changedInbox = true;
            rx.setLevel(0);
            if (rPtr==wPtr)
                ds.setCurrent(this);
        }
    }
    
    void send(byte[] data, String receiver) {
        //        byte[] data = sdata.getBytes();
        byte[] tdata = new byte[140];
        byte[] hdata = {
            (byte)'/',(byte)'/',(byte)'S',(byte)'E',(byte)'O', //ID
            (byte)0x01,                                     //Version
            (byte)0x70, (byte)0x00,                         //DataSize
            (byte)0x01, (byte)0x00, (byte)0x00, (byte)0x00, //ReferenceID
            (byte)0x01, (byte)0x00,                         //ActPacketNumber
            (byte)0x01, (byte)0x00,                         //NumberOfPackets
            (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00, //ObjectSize
            (byte)0x02, (byte)'j' , (byte)'d' ,             //ObjectType
            (byte)0x04,                                     //ObjectName
            (byte)'j' , (byte)'s' , (byte)'m' , (byte)'s' , // AppID
            (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00  // Port
        };
        if (data.length<108) {
            System.arraycopy(hdata, 0, tdata, 0, hdata.length);
            System.arraycopy(data, 0, tdata, hdata.length, data.length);
            tdata[16] = (byte)(data.length + 4);
            tdata[28] = (byte)100;
            try {
                com.siemens.mp.gsm.SMS.send(receiver, tdata);
            } catch (Exception e) {
                System.out.println(e.toString());
            }
        } else
            showAlert("Text too long:"+data.length);
    }
    
    private void registerListener() {
        if (conn==null) {
            conn = new Connection("SMS://:100");
            conn.setListener(this);
        }
    }
    
    private void removeListener() {
        conn.setListener(null);
        conn=null;
    }
    
    public void receiveData(byte[] data) {
        saveReceivedData(data);
    }
    private void saveReceivedData(byte[] data) {
        int length = data.length & 0xFF; // Stop buffer overrun
        byte[] buf = new byte[length];
        System.arraycopy(data, 0, buf, 0, length);
        in[wPtr] = buf;
        wPtr = (byte)((wPtr+1)%8);
        ds.setCurrent(rx);
    }
    
    public void storeReceivedData(int l) {
        if (rPtr!=wPtr) {
            rd = expand(in[rPtr]);
            rPtr = (byte)((rPtr+1)%8);
            for (int y=0;y<Board.Y_MAX;y++)
                for (int x=0;x<Board.X_MAX;x++)
                    gm.bd.b[l][y][x] = rd[y*Board.X_MAX+x];
        }
    }
    
    private void showAlert(String str) {
        Alert alert=new Alert("Error!", str, null, null);
        parent.display.setCurrent(alert);
    }
    
    // Input is array of 5 bit numbers
    // Returns array of packed 8 bit numbers
    public byte[] compress(byte[] in) {
        int i, j, k, t, size;
        
        // Run Length Encode
        i=0; j=0;
        while (i<in.length) {
            t = i;
            k = 0;
            while ((i<in.length-1) && ((in[i]!=in[i+1]) & (k<0x0F))) {
                i++;                  // Count length k of dissimilar run
                k++;
            }
            if ((i==in.length-1) & (k<0x0F)) {
                k++;
                i++;
            }
            if (k>0) {
                buf1[j++] = (byte)k;      // Store dissimilar run length
                while (t<i)
                    buf1[j++] = in[t++];  // Store each char in the run
            }
            k = 1;
            while ((i<in.length-1) && ((in[i]==in[i+1]) & (k<0x0F))) {
                i++;              // Count length k of similar run
                k++;
            }
            if (k>1) {
                buf1[j++] = (byte)(0x10 + k);// Store similar run length
                buf1[j++] = in[i++];            // Store char
            }
        }
        buf1[j] = (byte)0x00;                 // End of File
        size = j; // Size of packed data
        
        // Pack into bytes
        i=0; j=0;
        while (i<size) {
            buf2[j+0]=(byte)(buf1[i+0]+(((buf1[i+1])&0x07)<<5));// 5+3
            buf2[j+1]=(byte)((((buf1[i+1])&0x18)>>3)+((buf1[i+2])<<2)
            + (((buf1[i+3])&0x01)<<7));                                // 2+5+1
            buf2[j+2]=(byte)((((buf1[i+3])&0x1E)>>1)+(((buf1[i+4])&0x0F)<<4));// 4+4
            buf2[j+3]=(byte)((((buf1[i+4])&0x10)>>4)+ ((buf1[i+5])<<1)
            + (((buf1[i+6])&0x03)<<6));                                // 1+5+2
            buf2[j+4]=(byte)((((buf1[i+6])&0x1C)>>2)+ ((buf1[i+7])<<3));// 3+5
            i+=8; j+=5;
        }
        
        // Calculate required buffer size rounding up
        size = (size*5+7)/8;
        out = new byte[size];
        for (i=0;i<size;i++)
            out[i] = buf2[i];
        return out;
    }
    
    // Input is array of packed 8 bit numbers
    // Returns array of 5 bit numbers
    public byte[] expand(byte[] in) {
        int i, j, k, size;
        
        // Expand to full buffer size
        for (i=0;i<in.length;i++)
            buf1[i] = in[i];
        
        // Unpack into 5 bit numbers
        i=0; j=0;
        while (i<in.length) {
            buf2[j+0]=(byte)(  (buf1[i+0])&0x1F);                              // 5
            buf2[j+1]=(byte)((((buf1[i+0])&0xE0)>>5)+(((buf1[i+1])&0x03)<<3)); // 3+2
            buf2[j+2]=(byte)((((buf1[i+1])&0x7C)>>2));                         // 5
            buf2[j+3]=(byte)((((buf1[i+1])&0x80)>>7)+(((buf1[i+2])&0x0F)<<1)); // 1+4
            buf2[j+4]=(byte)((((buf1[i+2])&0xF0)>>4)+(((buf1[i+3])&0x01)<<4)); // 4+1
            buf2[j+5]=(byte)((((buf1[i+3])&0x3E)>>1));                         // 5
            buf2[j+6]=(byte)((((buf1[i+3])&0xC0)>>6)+(((buf1[i+4])&0x07)<<2)); // 2+3
            buf2[j+7]=(byte)((((buf1[i+4])&0xF8)>>3));                         // 5
            i+=5; j+=8;
        }
        
        // Calculate length of unpacked data
        // We may be over by one character due to packing
        size = (in.length*8)/5;
        
        // Run Length Unencode
        i=0; j=0;
        while (i<size-1) {
            k = buf2[i]&0x0F;             // Length of run
            if ((buf2[i++]&0x10)==0) {
                // Run of dissimilar chars
                while (((k--)>0) & (j<256))
                    buf1[j++] = buf2[i++];
            } else {
                // Run of similar chars
                while (((k--)>0) & (j<256))
                    buf1[j++] = buf2[i];
                i++;
            }
        }
        size = j; // Now we know the exact size
        
        // Create buffer of the correct size and fill it
        out = new byte[size];
        for (i=0;i<size;i++)
            out[i] = buf1[i];
        return out;
    }
    
    public void run() {
        if (terminate) {
            if (saving)
                gm.bd.saveGame();
            gm.terminateGame();
            if (changedInbox)
                gm.bd.saveInbox();
            removeListener();
            parent.destroyApp(true);
        } else
            send(compress(sd), tx.number.getString());
    }
    
    class Options extends List {
        public Command backCommand;
        
        Options(SmsForm p) {
            super("Options", List.IMPLICIT);
            append("Set Level",null);
            append("Load Game",null);
            append("Edit Level",null);
            append("Copy Level",null);
            append("Send Level",null);
            append("Save Game",null);
            append("Exit",null);
            backCommand = new Command("Back", Command.SCREEN, 1);
            addCommand(backCommand);
            setCommandListener(p);
        }
    }
    class Level extends List {
        private int SET=0, COPY=1, SAVE=2;
        public int mode;
        public Command cancelCommand;
        
        Level(SmsForm p) {
            super(" ", List.IMPLICIT);
            append("Inbox",null);
            append("Level 1",null);
            append("Level 2",null);
            append("Level 3",null);
            append("Level 4",null);
            append("Level 5",null);
            cancelCommand = new Command("Cancel", Command.SCREEN, 1);
            addCommand(cancelCommand);
            setCommandListener(p);
        }
        
        public void setLevel(int l) {
            mode = SET;
            setSelectedIndex(l, true);
            if (l==0)
                setTitle("Level [Inbox]");
            else
                setTitle("Level ["+l+"]");
        }
        
        public void setCopyLevel(int l) {
            mode = COPY;
            setSelectedIndex(l, true);
            if (l==0)
                setTitle("Copy Inbox to:");
            else
                setTitle("Copy Level "+l+" to:");
        }
        
        public void setSaveLevel(int l) {
            mode = SAVE;
            setSelectedIndex(l, true);
            setTitle("Save As");
        }
        
        public int getLevel() {
            return getSelectedIndex();
        }
    }
    
    class Save extends Form {
        public Command yesCommand;
        public Command noCommand;
        
        Save(SmsForm p) {
            super("Save");
            append("Save Changes?");
            yesCommand = new Command("Yes", Command.OK, 1);
            noCommand = new Command("No", Command.SCREEN, 2);
            addCommand(yesCommand);
            addCommand(noCommand);
            setCommandListener(p);
        }
    }
    
    class SendForm extends Form {
        public TextField number;
        private StringItem si1,si2;
        Command sendCommand;
        Command cancelCommand;
        
        SendForm(SmsForm p) {
            super("Tilt");
            number = new TextField("Phone Number:","",15,TextField.PHONENUMBER);
            si1 = new StringItem("","Level (Bytes):");
            si2 = new StringItem("","Max (Bytes):107");
            sendCommand	 = new Command("Send", Command.SCREEN, 1);
            cancelCommand = new Command("Cancel", Command.SCREEN, 2);
            append(number);
            append(si1);
            append(si2);
            addCommand(sendCommand);
            addCommand(cancelCommand);
            setCommandListener(p);
        }
        
        public void setSize(int size) {
            si1.setText("Level (Bytes):"+size);
            if (size>107)
                removeCommand(sendCommand);
            else
                addCommand(sendCommand);
        }
        
    }
    
    class Receive extends Form {
        private StringItem si;
        private int level;
        public Command saveAsCommand;
        public Command okCommand;
        
        Receive(SmsForm p) {
            super("Tilt");
            si = new StringItem("","To: [Inbox]");
            level = 0;
            append("Level Received");
            append(si);
            okCommand = new Command("OK", Command.SCREEN, 1);
            saveAsCommand = new Command("Save As", Command.SCREEN, 2);
            addCommand(saveAsCommand);
            addCommand(okCommand);
            setCommandListener(p);
        }
        
        public int getLevel() {
            return level;
        }
        
        public void setLevel(int l) {
            level = l;
            if (l==0)
                si.setText("To: [Inbox]");
            else
                si.setText("To: [Level "+l+"]");
        }
    }
}

//-------------------------------------------------------------------------------------------------------------------------------
// NoSmsForm
//-------------------------------------------------------------------------------------------------------------------------------
class NoSmsForm extends Wrapper implements CommandListener, Runnable {
    Tilt parent;
    private Thread th1 = null, th2 = null;
    private boolean saving = false;
    private Command startCommand;
    private Command optionsCommand;
    public Game gm;
    public Options op;
    public Level lv;
    public Form hg;
    public Save sa;
    private boolean changedInbox = false, changed = false;
    Image level, gamepad, editpad;
    //
    //	constructor
    //
    NoSmsForm() {
        super("Tilt");
    }
    
    public void initialise(Tilt p) {
        parent = p;
        ds = Display.getDisplay(p);
        gm = new Game(this);
        op = new Options(this);
        lv = new Level(this);
        hg = new Form("Tilt");
        hg.append("Busy...");
        sa = new Save(this);
        gm.bd.loadInbox();
        try {
            level = Image.createImage("/Tilt/level.png");
            gamepad = Image.createImage("/Tilt/gamepad.png");
            editpad = Image.createImage("/Tilt/editpad.png");
        } catch (Exception e) { e.printStackTrace();}
        th1 = new Thread(gm);
        th1.start();
        append("Roll the ball to the entrance of the next level. "+
        "Don't fall back to the previous level.");
        append2(level);
        append("\nGame keys:");
        append2(gamepad);
        append("\nEdit keys:");
        append2(editpad);
        append("\nSELECT key saves.");
        append("\nCopyright Alan Waddington 2003. "+
        "Tilt is freeware and without warranty.");
        startCommand     = new Command("Start", Command.SCREEN, 1);
        optionsCommand	 = new Command("Options", Command.SCREEN, 2);
        addCommand(startCommand);
        addCommand(optionsCommand);
        setCommandListener(this);
    }
    
    public void reset(boolean reg) {
        ds.setCurrent(this);
    }
    
    private void append2(Image img) {
        append(new ImageItem(null, img, ImageItem.LAYOUT_LEFT | ImageItem.LAYOUT_NEWLINE_BEFORE, "failed"));
    }
    
    public void commandAction(Command cmd, Displayable disp) {
        if ( cmd == startCommand ) {
            gm.setNewGame();
            ds.setCurrent(gm);
        } else if ( cmd == optionsCommand ) {
            ds.setCurrent(op);
        } else if (( cmd == op.SELECT_COMMAND) & (disp == op)) {
            switch (op.getSelectedIndex()) {
                case 0: // Set
                    lv.setLevel(gm.getLevel());
                    ds.setCurrent(lv);
                    break;
                case 1: // Load
                    ds.setCurrent(hg);
                    changed = false;
                    gm.loadGame();
                    break;
                case 2: // Edit
                    if (gm.getLevel()>0)
                        changed = true;
                    else
                        changedInbox = true;
                    gm.setEditMode();
                    ds.setCurrent(gm);
                    break;
                case 3: // Copy
                    lv.setCopyLevel(gm.getLevel());
                    ds.setCurrent(lv);
                    break;
                case 4: // Save
                    ds.setCurrent(hg);
                    changed = false;
                    gm.saveGame();
                    break;
                case 5: // Exit
                    if (changed)
                        ds.setCurrent(sa);
                    else {
                        saving = false;
                        ds.setCurrent(hg);
                        th2 = new Thread(this);
                        th2.start();
                    }
                    break;
            }
        } else if ((cmd == op.backCommand) & (disp == op)) {
            ds.setCurrent(this);
        } else if ((cmd == lv.SELECT_COMMAND) & (disp == lv)) {
            switch (lv.mode) {
                case 0: // Set
                    gm.setLevel(lv.getSelectedIndex());
                    ds.setCurrent(this);
                    break;
                case 1: // Copy
                    gm.copyLevel(lv.getSelectedIndex());
                    if (lv.getLevel()>0)
                        changed = true;
                    else
                        changedInbox = true;
                    ds.setCurrent(this);
                    break;
            }
        } else if ((cmd == lv.cancelCommand) & (disp == lv)) {
            switch (lv.mode) {
                case 0: // Set
                case 1: // Copy
                    ds.setCurrent(this);
                    break;
            }
        } else if ((cmd == sa.yesCommand) & (disp == sa)) {
            saving = true;
            ds.setCurrent(hg);
            th2 = new Thread(this);
            th2.start();
        } else if ((cmd == sa.noCommand) & (disp == sa)) {
            saving = false;
            ds.setCurrent(hg);
            th2 = new Thread(this);
            th2.start();
        }
    }
    
    public void run() {
        if (saving)
            gm.bd.saveGame();
        gm.terminateGame();
        if (changedInbox)
            gm.bd.saveInbox();
        parent.destroyApp(true);
    }
    
    class Options extends List {
        public Command backCommand;
        
        Options(NoSmsForm p) {
            super("Options", List.IMPLICIT);
            append("Set Level",null);
            append("Load Game",null);
            append("Edit Level",null);
            append("Copy Level",null);
            append("Save Game",null);
            append("Exit",null);
            backCommand = new Command("Back", Command.SCREEN, 1);
            addCommand(backCommand);
            setCommandListener(p);
        }
    }
    
    class Level extends List {
        private int SET=0, COPY=1;
        public int mode;
        public Command cancelCommand;
        
        Level(NoSmsForm p) {
            super(" ", List.IMPLICIT);
            append("Inbox",null);
            append("Level 1",null);
            append("Level 2",null);
            append("Level 3",null);
            append("Level 4",null);
            append("Level 5",null);
            cancelCommand = new Command("Cancel", Command.SCREEN, 1);
            addCommand(cancelCommand);
            setCommandListener(p);
        }
        
        public void setLevel(int l) {
            mode = SET;
            setSelectedIndex(l, true);
            if (l==0)
                setTitle("Level [Inbox]");
            else
                setTitle("Level ["+l+"]");
        }
        
        public void setCopyLevel(int l) {
            mode = COPY;
            setSelectedIndex(l, true);
            if (l==0)
                setTitle("Copy Inbox to:");
            else
                setTitle("Copy Level "+l+" to:");
        }
        
        public int getLevel() {
            return getSelectedIndex();
        }
    }
    
    class Save extends Form {
        public Command yesCommand;
        public Command noCommand;
        
        Save(NoSmsForm p) {
            super("Save");
            append("Save Changes?");
            yesCommand = new Command("Yes", Command.OK, 1);
            noCommand = new Command("No", Command.SCREEN, 2);
            addCommand(yesCommand);
            addCommand(noCommand);
            setCommandListener(p);
        }
    }
}

